var getAnnotationPopupButtons = function(annotManager, annotation) {
  var documentButton = {
    type: 'actionButton',
    label: annotation instanceof Annotations.FreeHandAnnotation ? 'S' : 'M', // just an example, add your own logic here
    onClick: function() {},
    title: 'Custom action button',
    dataElement: 'customDocumentButton'
  };

  var indexButton = {
    type: 'actionButton',
    label: annotManager.getAnnotationsList().indexOf(annotation),
    onClick: function() {},
    title: 'Custom action button',
    dataElement: 'customIndexButton'
  };

  var customActionButton = {
    type: 'actionButton',
    img: '<svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" viewBox="0 0 24 24" fill="currentColor">' +
      '<path d="M12 7.77L18.39 18H5.61L12 7.77M12 4L2 20h20L12 4z"/>' +
      '<path fill="none" d="M0 0h24v24H0V0z"/>' +
    '</svg>',
    onClick: function() {
      console.log(annotation);
    },
    title: 'Custom action button',
    dataElement: 'customActionButton'
  };

  return [documentButton, indexButton, customActionButton];
};

$(document).on('viewerLoaded', function() {
  var viewerInstance = readerControl;
  var annotManager = viewerInstance.docViewer.getAnnotationManager();

  annotManager.on('annotationSelected', function(e, annotations, action) {
    if (action === 'selected') {
      if (annotations.length === 1) {
        viewerInstance.setAnnotationPopupItems(getAnnotationPopupButtons(annotManager, annotations[0]));
      }
    }
  });
});